package com.persagy.service.impl;

/**
 * @description:
 * @author:LuoGuangyi
 * @company:PersagyTechnologyCo.,Ltd
 * @since:2020/10/17 001710:12
 * @version:V1.0
 **/
import cn.hutool.core.date.DateUtil;
import cn.hutool.core.date.TimeInterval;
import com.googlecode.aviator.AviatorEvaluator;
import com.googlecode.aviator.Expression;
import com.googlecode.aviator.Options;

import java.util.Arrays;

/**
 * Run a script under examples folder.
 *
 * @author dennis(killme2008@gmail.com)
 *
 */
public class RunScriptExample {

    public static void main(final String[] args) throws Exception {
        // You can try to test every script in examples folder by changing the file name.

        TimeInterval timer = DateUtil.timer();
        String expression = "$a-($b-$c) > 100";
        String expression2 = "$a-($b-$c) > 200";
        String expression3 = "$a-($b-$c) > 200";
        Expression compiledExp = AviatorEvaluator.compile(expression,true);
        Expression compiledExp2 = AviatorEvaluator.compile(expression2,true);
        System.out.println(AviatorEvaluator.getInstance().getExpressionCacheSize());
        Boolean result1 = (Boolean) compiledExp.execute(compiledExp.newEnv("$a", 100.3, "$b", 45, "$c", -199.100));
        Boolean result2 = (Boolean) compiledExp.execute(compiledExp2.newEnv("$a", 100.3, "$b", 45, "$c", -199.100));

        System.out.println(AviatorEvaluator.getInstance().getExpressionCacheSize());

        Expression exp = AviatorEvaluator.getInstance().compileScript("statements.av",true);
        System.out.println(AviatorEvaluator.getInstance().getExpressionCacheSize());
        for (int i = 0; i < 10000; i++) {
            Object result = exp.execute(exp.newEnv("$a", 100.3, "$b", 45, "$c", -199.100,"$list", Arrays.asList(1,3)));
//            System.out.println(result);
        }
        //花费毫秒数
        System.out.println(timer.interval());
        timer.intervalRestart();
        Expression compiledExp3 = AviatorEvaluator.compile(expression3,true);
        for (int i = 0; i < 50000; i++) {
            Boolean result3 = (Boolean) compiledExp.execute(compiledExp3.newEnv("$a", 100.3, "$b", i, "$c", -199.100));
        }
        System.out.println(timer.interval());
//        String expression = "$a-($b-$c) > 100";
//        Expression compiledExp = AviatorEvaluator.compile(expression);
//        // Execute with injected variables.
//        Boolean result = (Boolean) compiledExp.execute(compiledExp.newEnv("$a", 100.3, "$b", 45, "c", -199.100));
//        System.out.println(result);
    }
}
